import java.awt.*;
import javax.swing.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;

public class DarkMessenger implements ActionListener, Runnable {
	
	public static int PORT	  = 8080;
		
	Socket s;
	ServerSocket ss;
	String host, friend, tof, txt;
	int port;
	PrintStream ps;
	JFrame frame;
	Container cp;
	JTextField hostf, typed;
	JTextArea area;
    	JButton btn, clr;
    	JLabel lb1, lb2, lb3, lbfarlokka;
    	JScrollPane jsp;
    	Thread t;
    	BufferedReader q;
    	boolean test;
    	boolean connected;
    	boolean server;
	
	public DarkMessenger() {
		this.port = PORT;
		this.server = false;
		test = true;
		createGUI();
		serverup();		
	}				
	
	public void run() {
		try {				
			q = new BufferedReader(new InputStreamReader(s.getInputStream()));			
				while((txt = q.readLine()) != null) {				
					area.append(txt + "\n");
			}
		}catch(Exception e) {}
	}
	public void connect(String host) {
		try {			
			s = new Socket(host, port);			
			area.setText("Trying to connect...\n");
			area.append("Connected with " + host + " !\n"); 
			typed.setEditable(true);
			hostf.setEditable(false);
			if(s != null)
				connected = true;
			ps = new PrintStream(s.getOutputStream());
			t = new Thread(this);	
			t.start();			
		} catch(Exception e) {
			area.setText("Error during connection !\n");
			connected = false;
			btn.setText("Connect");
		}
	}
	
	public void actionPerformed(ActionEvent e){
		if((e.getActionCommand() == "Connect") && !hostf.getText().equals("")) {			
			friend = hostf.getText();
			tof = typed.getText();
			btn.setText("Send");
			connect(friend);
			clr.setEnabled(true);
		}
		
		if((e.getActionCommand() == "Connect") && hostf.getText().equals("")) {
			area.append("Type a friend !\n");
		}
		
		if(e.getActionCommand() == "Close connection"){
			area.setText("");
			typed.setText("");
			hostf.setEditable(true);
			t = null;
			close();
		}
		if(e.getActionCommand() == "Send"){
			String texto = typed.getText();
			ps.println(texto);
			typed.setText("");
		}					
	}
	
	public void serverup() {
		try {
			ss = new ServerSocket(port);
			while(true) { 
				s = ss.accept();
				server = true;
				area.append("Connection from " + s.getInetAddress() + " accepted.\n");
				ps = new PrintStream(s.getOutputStream());
				typed.setEditable(true);
				hostf.setEditable(false);
				btn.setText("Send");
				t = new Thread(this);	
				t.start();				
			}
		}
		catch(Exception e) {
			System.out.println("Error :" + e);
		}
	}
	
	public void createGUI() {
		frame = new JFrame("-= Dark Messenger =-");
		frame.setSize(250, 350);
		frame.setResizable(false);
		cp = frame.getContentPane();
		hostf = new JTextField(10);
    		typed = new JTextField(10);
    		typed.setEditable(false);
    		area = new JTextArea(10, 10);
    		area.setEditable(false);
    		btn = new JButton("Connect");
    		btn.setSelected(true);
    		clr = new JButton("Close connection");
    		clr.setEnabled(false);
    		lb1 = new JLabel("Friend :");
    		lb2 = new JLabel("Type :");
    		lb3 = new JLabel("Your chat :");
    		lbfarlokka = new JLabel("");
    		jsp = new JScrollPane(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED , JScrollPane.HORIZONTAL_SCROLLBAR_NEVER); 
    		GridBagLayout gridbag = new GridBagLayout();
    		GridBagConstraints c = new GridBagConstraints();
    		cp.setLayout(gridbag);
    		c.ipadx = 2;
    		c.ipady = 4;
    		
    		c.fill = GridBagConstraints.BOTH;
    		c.weightx = 0.0;
    		gridbag.setConstraints(lb1, c);
    		cp.add(lb1);
    		
    		c.gridwidth = GridBagConstraints.REMAINDER; 
    		gridbag.setConstraints(hostf, c);
    		cp.add(hostf);
    		
    		c.gridwidth = GridBagConstraints.REMAINDER;
    		gridbag.setConstraints(lb3, c);
    		cp.add(lb3);
    		
    		c.gridwidth = GridBagConstraints.REMAINDER;
    		gridbag.setConstraints(jsp, c);
    		cp.add(jsp);
    		
    		jsp.setViewportView(area);
    		
    		c.gridwidth = GridBagConstraints.RELATIVE;
    		c.weightx = 1.0;
    		gridbag.setConstraints(lb2, c);
    		cp.add(lb2);
    		
    		c.gridwidth = GridBagConstraints.REMAINDER;
    		gridbag.setConstraints(lbfarlokka, c);
    		cp.add(lbfarlokka);
    		
    		c.gridwidth = GridBagConstraints.RELATIVE;
    		gridbag.setConstraints(typed, c);
    		cp.add(typed);
    		
    		c.gridwidth = GridBagConstraints.REMAINDER;
    		gridbag.setConstraints(btn, c);
    		cp.add(btn);
    		
    		c.gridwidth = GridBagConstraints.REMAINDER;
    		gridbag.setConstraints(clr, c);
    		cp.add(clr);
    		
    		frame.setVisible(true);
		frame.show();
		btn.addActionListener(this);
		clr.addActionListener(this);
	}
	
	public void close() {
		if(s != null) {
			try {s.close();}
		 	catch(Exception e) {System.out.println(e.toString());}
		 	connected = false;
		 }
	}	
}